package com.trs.ggzyexchange.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.trs.ggzyexchange.api.vo.Result;
import com.trs.ggzyexchange.entity.*;
import com.trs.ggzyexchange.entity.pagedata.*;
import com.trs.ggzyexchange.enums.CommonConstant;
import com.trs.ggzyexchange.mapper.GcTenderprojectMapper;
import com.trs.ggzyexchange.service.*;
import com.trs.ggzyexchange.utils.DateUtils;
import com.trs.ggzyexchange.utils.RedisUtil;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.time.DateFormatUtils;
import org.elasticsearch.client.ml.EvaluateDataFrameRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.util.*;

/*
* 数据中心接口
* */
@Slf4j
@RestController
@RequestMapping("/data-controller")
public class DataController {


    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;

    @Autowired
    private AreaPlatformService areaPlatformService;

    @Autowired
    private GcPubContractService gcPubContractService;

    @Autowired
    private GcBidpublicityService gcBidpublicityService;

    @Autowired
    private ZtLegalinfoService ztLegalinfoService;

    @Autowired
    private TRegionService tRegionService;

    @Autowired
    private GcTenderprojectService gcTenderprojectService;
    @Autowired
    private ZrzyTdCedeNoticeService zrzyTdCedeNoticeService;

    @Autowired
    private CqSwIssueBulletinService cqSwIssueBulletinService;

    @Autowired
    private ZcPurchaseBulletinService zcPurchaseBulletinService;

    @Autowired
    private QtjyNoticeService qtjyNoticeService;

    @Autowired
    private ZcBidpublicityService zcBidpublicityService;

    @Autowired
    private ZrzyTdBidwinnoticeService zrzyTdBidwinnoticeService;

    @Autowired
    private CqSwBargainResultService cqSwBargainResultService;

    @Autowired
    private CqGqIssueBulletinService cqGqIssueBulletinService;

    @Autowired
    private CqGqBargainResultService cqGqBargainResultService;


    @Autowired
    private QtjyBidpublicityService qtjyBidpublicityService;

    @Autowired
    private ZcProjectService zcProjectService;

    @Autowired
    private QtjyTenderProjectService qtjyTenderProjectService;

    @Autowired
    private QtjyBidopenrecordService qtjyBidopenrecordService;

    @Autowired
    private ZcBidopenrecordService zcBidopenrecordService;


    @Autowired
    private RedisUtil redisUtil;

    @GetMapping(value = "/listTotal")
    public Result<FirstPageData> queryPageListTotal() {
        FirstPageData firstPageData = null;
        Object firstPageDataObj = redisUtil.get(CommonConstant.LIST_TOTAL);
        if(!ObjectUtils.isEmpty(firstPageDataObj)){
            firstPageData = JSONObject.parseObject(firstPageDataObj.toString(),FirstPageData.class);
            return Result.OK(firstPageData);
        }else{
            firstPageData = new FirstPageData();
        }
        //内蒙古自治区：121500004600236091
        /*
        * 交易数据总量
        * */
        BusinessDataStatistics businessDataStatistics = new BusinessDataStatistics();
        businessDataStatistics.setBusinessTotalData(gcBidpublicityService.count());

        QueryWrapper<GcBidpublicity> gcBidpublicityQueryWrapper = new QueryWrapper<GcBidpublicity>();
        gcBidpublicityQueryWrapper.eq("PLATFORM_CODE","121500004600236091");

        QueryWrapper<ZcBidpublicity> zcBidpublicityQueryWrapper = new QueryWrapper<ZcBidpublicity>();
        zcBidpublicityQueryWrapper.eq("PLATFORM_CODE","121500004600236091");

        QueryWrapper<ZrzyTdBidwinnotice> zrzyTdBidwinnoticeQueryWrapper = new QueryWrapper<ZrzyTdBidwinnotice>();
        zrzyTdBidwinnoticeQueryWrapper.eq("PLATFORM_CODE","121500004600236091");

        QueryWrapper<CqSwBargainResult> cqSwBargainResultQueryWrapper = new QueryWrapper<CqSwBargainResult>();
        cqSwBargainResultQueryWrapper.eq("PLATFORM_CODE","121500004600236091");

        QueryWrapper<CqGqBargainResult> cqGqBargainResultQueryWrapper = new QueryWrapper<CqGqBargainResult>();
        cqGqBargainResultQueryWrapper.eq("PLATFORM_CODE","121500004600236091");

        QueryWrapper<QtjyBidpublicity> qtjyBidpublicityQueryWrapper = new QueryWrapper<QtjyBidpublicity>();
        qtjyBidpublicityQueryWrapper.eq("PLATFORM_CODE","121500004600236091");

        int count3 = gcBidpublicityService.count(gcBidpublicityQueryWrapper);
        int count31 = zcBidpublicityService.count(zcBidpublicityQueryWrapper);
        int count32 = zrzyTdBidwinnoticeService.count(zrzyTdBidwinnoticeQueryWrapper);
        int count33 = cqSwBargainResultService.count(cqSwBargainResultQueryWrapper);
        int count34 = cqGqBargainResultService.count(cqGqBargainResultQueryWrapper);
        int count35 = qtjyBidpublicityService.count(qtjyBidpublicityQueryWrapper);

        businessDataStatistics.setBusinessAutonomousTotalData(count3 + count31 + count32 + count33 + count34 + count35);

        int count4 = gcBidpublicityService.count() - gcBidpublicityService.count(gcBidpublicityQueryWrapper);
        int count41 = zcBidpublicityService.count() -  zcBidpublicityService.count(zcBidpublicityQueryWrapper);
        int count42 = zrzyTdBidwinnoticeService.count() -  zrzyTdBidwinnoticeService.count(zrzyTdBidwinnoticeQueryWrapper);
        int count43 = cqSwBargainResultService.count() - cqSwBargainResultService.count(cqSwBargainResultQueryWrapper);
        int count44 = cqGqIssueBulletinService.count() - cqGqBargainResultService.count(cqGqBargainResultQueryWrapper);
        int count45 = qtjyBidpublicityService.count() - qtjyBidpublicityService.count(qtjyBidpublicityQueryWrapper);

        businessDataStatistics.setBusinessMengShiTotalData(count4 + count41 + count42 + count43 + count44 + count45);
        /*
        *主体数量
        */
        SubDataStatistics subDataStatistics = new SubDataStatistics();
        subDataStatistics.setSubTotalData(ztLegalinfoService.count());
        QueryWrapper<ZtLegalinfo> ztLegalinfoQueryWrapper = new QueryWrapper<ZtLegalinfo>();
        ztLegalinfoQueryWrapper.likeRight("REGION_CODE","15");
        subDataStatistics.setIntraRegional(ztLegalinfoService.count(ztLegalinfoQueryWrapper));
        subDataStatistics.setOutOfRegion(ztLegalinfoService.count() - ztLegalinfoService.count(ztLegalinfoQueryWrapper));

        /*
        * 总数
        * */
        DataStatistics dataStatistics = new DataStatistics();

        Integer subTotalData = subDataStatistics.getSubTotalData();
        Integer businessTotalData = businessDataStatistics.getBusinessTotalData();
        dataStatistics.setTotalData(subTotalData+businessTotalData);
        dataStatistics.setAutonomousTotalData(subTotalData+businessDataStatistics.getBusinessAutonomousTotalData());
        dataStatistics.setMengShiTotalData(subTotalData+businessDataStatistics.getBusinessMengShiTotalData());


        /*
        * 交易额总量
        * */
        QueryWrapper<GcBidpublicity> gcBidpublicityQueryWrapperSum = new QueryWrapper<GcBidpublicity>();
        gcBidpublicityQueryWrapperSum.select("sum( case when PRICE_UNIT = 0 then BID_AMOUNT when PRICE_UNIT = 1 then BID_AMOUNT*10000 else BID_AMOUNT end) as sumAll");
        GcBidpublicity gcBidpublicity = gcBidpublicityService.getOne(gcBidpublicityQueryWrapperSum);

        QueryWrapper<ZcBidpublicity> bidpublicityQueryWrapperSum = new QueryWrapper<ZcBidpublicity>();
        bidpublicityQueryWrapperSum.select("sum( case when PRICE_UNIT = 0 then WIN_BID_PRICE when PRICE_UNIT = 1 then WIN_BID_PRICE*10000 else WIN_BID_PRICE end) as sumAll");
        ZcBidpublicity zcBidpublicitySum = zcBidpublicityService.getOne(bidpublicityQueryWrapperSum);

        QueryWrapper<ZrzyTdBidwinnotice> zrzyTdBidwinnoticeQuerySum = new QueryWrapper<ZrzyTdBidwinnotice>();
        zrzyTdBidwinnoticeQuerySum.select("sum( case when PRICE_UNIT = 0 then DEAL_PRICE when PRICE_UNIT = 1 then DEAL_PRICE*10000 else DEAL_PRICE end) as sumAll");
        ZrzyTdBidwinnotice zrzyTdBidwinnoticeSum = zrzyTdBidwinnoticeService.getOne(zrzyTdBidwinnoticeQuerySum);

        QueryWrapper<CqSwBargainResult> cqSwBargainResultQueryWrapperSum = new QueryWrapper<CqSwBargainResult>();
        cqSwBargainResultQueryWrapperSum.select("sum( case when PRICE_UNIT = 0 then TRADE_VALUE when PRICE_UNIT = 1 then TRADE_VALUE*10000 else TRADE_VALUE end) as sumAll");
        CqSwBargainResult cqSwBargainResultSum = cqSwBargainResultService.getOne(cqSwBargainResultQueryWrapperSum);

        QueryWrapper<CqGqBargainResult> cqGqBargainResultQueryWrapperSum = new QueryWrapper<CqGqBargainResult>();
        cqGqBargainResultQueryWrapperSum.select("sum( case when PRICE_UNIT = 0 then TRADE_VALUE when PRICE_UNIT = 1 then TRADE_VALUE*10000 else TRADE_VALUE end) as sumAll");
        CqGqBargainResult cqGqBargainResult = cqGqBargainResultService.getOne(cqGqBargainResultQueryWrapperSum);

        QueryWrapper<QtjyBidpublicity> qtjyBidpublicityQueryWrapperSum = new QueryWrapper<QtjyBidpublicity>();
        qtjyBidpublicityQueryWrapperSum.select("sum(BID_AMOUNT) as sumAll");
        QtjyBidpublicity qtjyBidpublicitySum = qtjyBidpublicityService.getOne(qtjyBidpublicityQueryWrapperSum);


        String gcBidpublicitySumAll = null;
        if(!ObjectUtils.isEmpty(gcBidpublicity)){
            gcBidpublicitySumAll = gcBidpublicity.getSumAll();
        }
        String zcBidpublicitySumsumAll = null;
        if(!ObjectUtils.isEmpty(zcBidpublicitySum)){
            zcBidpublicitySumsumAll = gcBidpublicity.getSumAll();
        }
        String zrzyTdBidwinnoticeSumsumAll = null;
        if(!ObjectUtils.isEmpty(zrzyTdBidwinnoticeSum)){
            zrzyTdBidwinnoticeSumsumAll = gcBidpublicity.getSumAll();
        }
        String SwBargainResultSumAll = null;
        if(!ObjectUtils.isEmpty(cqSwBargainResultSum)){
            SwBargainResultSumAll = gcBidpublicity.getSumAll();
        }
        String GqBargainResultSumAll = null;
        if(!ObjectUtils.isEmpty(cqGqBargainResult)){
            GqBargainResultSumAll = gcBidpublicity.getSumAll();
        }
        String BidpublicitySumAll = null;
        if(!ObjectUtils.isEmpty(qtjyBidpublicitySum)){
            BidpublicitySumAll = gcBidpublicity.getSumAll();
        }

        BigDecimal bigDecimalgcBidpublicity = null;
        if(!ObjectUtils.isEmpty(gcBidpublicitySumAll)){
            bigDecimalgcBidpublicity = new BigDecimal(gcBidpublicitySumAll);
        }else{
            bigDecimalgcBidpublicity = new BigDecimal(0);
        }
        BigDecimal bigDecimalzcBidpublicity = null;
        if(!ObjectUtils.isEmpty(zcBidpublicitySumsumAll)){
            bigDecimalzcBidpublicity = new BigDecimal(zcBidpublicitySumsumAll);
        }else{
            bigDecimalzcBidpublicity = new BigDecimal(0);
        }
        BigDecimal bigDecimalzrzyTdBidwinnotice = null;
        if(!ObjectUtils.isEmpty(zrzyTdBidwinnoticeSumsumAll)){
            bigDecimalzrzyTdBidwinnotice = new BigDecimal(zrzyTdBidwinnoticeSumsumAll);
        }else{
            bigDecimalzrzyTdBidwinnotice = new BigDecimal(0);
        }
        BigDecimal SwBargainResultSumAllcity = null;
        if(!ObjectUtils.isEmpty(SwBargainResultSumAll)){
            SwBargainResultSumAllcity = new BigDecimal(SwBargainResultSumAll);
        }else{
            SwBargainResultSumAllcity = new BigDecimal(0);
        }
        BigDecimal GqIssueBulletinSumAllcity = null;
        if(!ObjectUtils.isEmpty(GqBargainResultSumAll)){
            GqIssueBulletinSumAllcity = new BigDecimal(GqBargainResultSumAll);
        }else{
            GqIssueBulletinSumAllcity = new BigDecimal(0);
        }
        BigDecimal BidpublicitySumAllwinnotice = null;
        if(!ObjectUtils.isEmpty(BidpublicitySumAll)){
            BidpublicitySumAllwinnotice = new BigDecimal(BidpublicitySumAll);
        }else{
            BidpublicitySumAllwinnotice = new BigDecimal(0);
        }
         /*
        交易额总数
        */
        firstPageData.setTotalTransactionVolume(
                bigDecimalgcBidpublicity
                        .add(bigDecimalzcBidpublicity)
                        .add(bigDecimalzrzyTdBidwinnotice)
                        .add(SwBargainResultSumAllcity)
                        .add(GqIssueBulletinSumAllcity)
                        .add(BidpublicitySumAllwinnotice).toString());
        /*
        成交宗数宗量
        */
        firstPageData.setTotalNumberTransactions(
                gcBidpublicityService.count()+
                zcBidpublicityService.count()+
                zrzyTdBidwinnoticeService.count()+
                cqSwBargainResultService.count()+
                cqGqBargainResultService.count()+
                qtjyBidpublicityService.count()
        );

        List<CityTradeData> cityTradeDataList = new ArrayList<CityTradeData>();
        //查询盟市列表
        QueryWrapper<TRegion> tRegionQueryWrapper = new QueryWrapper<TRegion>();
        tRegionQueryWrapper.eq("parent_code","150000");
        tRegionQueryWrapper.orderByAsc("order_num");

        List<TRegion> list = tRegionService.list(tRegionQueryWrapper);

        for (TRegion tRegion : list) {
            String code = tRegion.getCode();
            QueryWrapper<AreaPlatform> platformQueryWrapper = new QueryWrapper<AreaPlatform>();
            platformQueryWrapper.eq("AREA_CODE",code);
            AreaPlatform areaPlatform = areaPlatformService.getOne(platformQueryWrapper);
            if(!ObjectUtils.isEmpty(areaPlatform)){
                tRegion.setCode(tRegion.getCode().substring(0,4));
                tRegion.setCodePram(areaPlatform.getPlatformCode());
                CityTradeData cityTradeData = new CityTradeData();
                cityTradeData.setCityName(tRegion.getName());
                cityTradeData.setRegionCode(tRegion.getCode());
                cityTradeData.setPlatformCode(areaPlatform.getPlatformCode());
                String regionCode = cityTradeData.getRegionCode();
                String platformCode = cityTradeData.getPlatformCode();

                QueryWrapper<GcBidpublicity> gcBidpublicityQueryWrapperIn = new QueryWrapper<GcBidpublicity>();
                gcBidpublicityQueryWrapperIn.eq("PLATFORM_CODE",platformCode);

                QueryWrapper<ZcBidpublicity> zcBidpublicityQueryWrapperC = new QueryWrapper<ZcBidpublicity>();
                zcBidpublicityQueryWrapperC.eq("PLATFORM_CODE",platformCode);

                QueryWrapper<ZrzyTdBidwinnotice> zrzyTdBidwinnoticeQueryWrapperC = new QueryWrapper<ZrzyTdBidwinnotice>();
                zrzyTdBidwinnoticeQueryWrapperC.eq("PLATFORM_CODE",platformCode);

                QueryWrapper<CqSwBargainResult> cqSwBargainResultQueryWrapperC = new QueryWrapper<CqSwBargainResult>();
                cqSwBargainResultQueryWrapperC.eq("PLATFORM_CODE",platformCode);

                QueryWrapper<CqGqBargainResult> cqGqBargainResultQueryWrapperC = new QueryWrapper<CqGqBargainResult>();
                cqGqBargainResultQueryWrapperC.eq("PLATFORM_CODE",platformCode);

                QueryWrapper<QtjyBidpublicity> qtjyBidpublicityQueryWrapperC = new QueryWrapper<QtjyBidpublicity>();
                qtjyBidpublicityQueryWrapperC.eq("PLATFORM_CODE",platformCode);

                cityTradeData.setBusinessTotalData(
                        gcBidpublicityService.count(gcBidpublicityQueryWrapperIn)+
                        zcBidpublicityService.count(zcBidpublicityQueryWrapperC)+
                        zrzyTdBidwinnoticeService.count(zrzyTdBidwinnoticeQueryWrapperC)+
                        cqSwBargainResultService.count(cqSwBargainResultQueryWrapperC)+
                        cqGqBargainResultService.count(cqGqBargainResultQueryWrapperC)+
                        qtjyBidpublicityService.count(qtjyBidpublicityQueryWrapperC)
                );

                QueryWrapper<ZtLegalinfo> ztLegalinfoQueryWrapperIn = new QueryWrapper<ZtLegalinfo>();
                ztLegalinfoQueryWrapperIn.likeRight("REGION_CODE",regionCode);
                cityTradeData.setSubTotalData(ztLegalinfoService.count(ztLegalinfoQueryWrapperIn));

                QueryWrapper<GcBidpublicity> gcBidpublicityQueryWrapperInSum = new QueryWrapper<GcBidpublicity>();
                gcBidpublicityQueryWrapperInSum.select("sum( case when PRICE_UNIT = 0 then BID_AMOUNT when PRICE_UNIT = 1 then BID_AMOUNT*10000 else BID_AMOUNT end) as sumAll");
                gcBidpublicityQueryWrapperInSum.eq("PLATFORM_CODE",platformCode);
                GcBidpublicity gcBidpublicityIn = gcBidpublicityService.getOne(gcBidpublicityQueryWrapperInSum);

                QueryWrapper<ZcBidpublicity> bidpublicityQueryWrapperIn = new QueryWrapper<ZcBidpublicity>();
                bidpublicityQueryWrapperIn.select("sum( case when PRICE_UNIT = 0 then WIN_BID_PRICE when PRICE_UNIT = 1 then WIN_BID_PRICE*10000 else WIN_BID_PRICE end) as sumAll");
                bidpublicityQueryWrapperIn.eq("PLATFORM_CODE",platformCode);
                ZcBidpublicity zcBidpublicityIn = zcBidpublicityService.getOne(bidpublicityQueryWrapperSum);

                QueryWrapper<ZrzyTdBidwinnotice> zrzyTdBidwinnoticeQueryIn = new QueryWrapper<ZrzyTdBidwinnotice>();
                zrzyTdBidwinnoticeQueryIn.select("sum( case when PRICE_UNIT = 0 then DEAL_PRICE when PRICE_UNIT = 1 then DEAL_PRICE*10000 else DEAL_PRICE end) as sumAll");
                zrzyTdBidwinnoticeQueryIn.eq("PLATFORM_CODE",platformCode);
                ZrzyTdBidwinnotice zrzyTdBidwinnoticeIn = zrzyTdBidwinnoticeService.getOne(zrzyTdBidwinnoticeQuerySum);

                QueryWrapper<CqSwBargainResult> cqSwBargainResultQueryWrapperIn = new QueryWrapper<CqSwBargainResult>();
                cqSwBargainResultQueryWrapperIn.select("sum( case when PRICE_UNIT = 0 then TRADE_VALUE when PRICE_UNIT = 1 then TRADE_VALUE*10000 else TRADE_VALUE end) as sumAll");
                cqSwBargainResultQueryWrapperIn.eq("PLATFORM_CODE",platformCode);
                CqSwBargainResult cqSwBargainResultIn = cqSwBargainResultService.getOne(cqSwBargainResultQueryWrapperSum);

                QueryWrapper<CqGqBargainResult> cqGqBargainResultQueryWrapperIn = new QueryWrapper<CqGqBargainResult>();
                cqGqBargainResultQueryWrapperIn.select("sum( case when PRICE_UNIT = 0 then TRADE_VALUE when PRICE_UNIT = 1 then TRADE_VALUE*10000 else TRADE_VALUE end) as sumAll");
                cqGqBargainResultQueryWrapperIn.eq("PLATFORM_CODE",platformCode);
                CqGqBargainResult cqGqBargainResultIn = cqGqBargainResultService.getOne(cqGqBargainResultQueryWrapperSum);

                QueryWrapper<QtjyBidpublicity> qtjyBidpublicityQueryWrapperIn = new QueryWrapper<QtjyBidpublicity>();
                qtjyBidpublicityQueryWrapperIn.select("sum(BID_AMOUNT) as sumAll");
                qtjyBidpublicityQueryWrapperIn.eq("PLATFORM_CODE",platformCode);
                QtjyBidpublicity qtjyBidpublicityQueryWrapperInIn = qtjyBidpublicityService.getOne(qtjyBidpublicityQueryWrapperSum);

                BigDecimal bigTotal = new BigDecimal("0");
                if(!ObjectUtils.isEmpty(gcBidpublicityIn)){
                    String sumAllgcBidpublicity = gcBidpublicityIn.getSumAll();
                    BigDecimal bigsumAllgcBidpublicity = new BigDecimal(sumAllgcBidpublicity);
                    bigTotal = bigTotal.add(bigsumAllgcBidpublicity);
                }
                if(!ObjectUtils.isEmpty(zcBidpublicityIn)){
                    String sumAllzcBidpublicityIn = zcBidpublicityIn.getSumAll();
                    BigDecimal bigsumAllzcBidpublicityIn = new BigDecimal(sumAllzcBidpublicityIn);
                    bigTotal = bigTotal.add(bigsumAllzcBidpublicityIn);
                }
                if(!ObjectUtils.isEmpty(zrzyTdBidwinnoticeIn)){
                    String sumAllzrzyTdBidwinnoticeIn = zrzyTdBidwinnoticeIn.getSumAll();
                    BigDecimal bigsumAllzrzyTdBidwinnoticeIn = new BigDecimal(sumAllzrzyTdBidwinnoticeIn);
                    bigTotal = bigTotal.add(bigsumAllzrzyTdBidwinnoticeIn);
                }
                if(!ObjectUtils.isEmpty(cqSwBargainResultIn)){
                    String sumAllcqSwBargainResultIn = cqSwBargainResultIn.getSumAll();
                    BigDecimal BigsumAllcqSwBargainResultIn = new BigDecimal(sumAllcqSwBargainResultIn);
                    bigTotal = bigTotal.add(BigsumAllcqSwBargainResultIn);
                }
                if(!ObjectUtils.isEmpty(cqGqBargainResultIn)){
                    String sumAllcqGqBargainResultIn = cqGqBargainResultIn.getSumAll();
                    BigDecimal BigsumAllcqGqBargainResultIn = new BigDecimal(sumAllcqGqBargainResultIn);
                    bigTotal = bigTotal.add(BigsumAllcqGqBargainResultIn);
                }
                if(!ObjectUtils.isEmpty(qtjyBidpublicityQueryWrapperInIn)){
                    String sumAllqtjyBidpublicity = qtjyBidpublicityQueryWrapperInIn.getSumAll();
                    BigDecimal BidsumAllqtjyBidpublicity = new BigDecimal(sumAllqtjyBidpublicity);
                    bigTotal = bigTotal.add(BidsumAllqtjyBidpublicity);
                }
                cityTradeData.setTotalTransactionVolume(
                        bigTotal.toString()
                );
                QueryWrapper<GcBidpublicity> gcBidpublicityQueryWrapperInCount = new QueryWrapper<GcBidpublicity>();
                gcBidpublicityQueryWrapperInCount.eq("PLATFORM_CODE",platformCode);
                int count = gcBidpublicityService.count(gcBidpublicityQueryWrapperInCount);
                if(!ObjectUtils.isEmpty(count)){
                    cityTradeData.setTotalNumberTransactions(count);
                }
                cityTradeDataList.add(cityTradeData);
            }
        }
        firstPageData.setCityTradeDataList(cityTradeDataList);
        firstPageData.setSubDataStatistics(subDataStatistics);
        firstPageData.setBusinessDataStatistics(businessDataStatistics);
        firstPageData.setDataStatistics(dataStatistics);
        redisUtil.set(CommonConstant.LIST_TOTAL, JSONObject.toJSONString(firstPageData),CommonConstant.REDIS_SAVE_TIME);
        return Result.OK(firstPageData);
    }

    @GetMapping(value = "/quantityStatisticsDayList")
    public Result<QuantityStatisticsAll> getQuantityStatisticsDayList(){
        QuantityStatisticsAll quantityStatisticsAll = null;
        Object quantityStatisticsAllObj = redisUtil.get(CommonConstant.STATISTICS_DAY);
        if(!ObjectUtils.isEmpty(quantityStatisticsAllObj)){
            quantityStatisticsAll = JSONObject.parseObject(quantityStatisticsAllObj.toString(),QuantityStatisticsAll.class);
            return Result.OK(quantityStatisticsAll);
        }else{
            quantityStatisticsAll = new QuantityStatisticsAll();
        }
        Date startTimeOfCurrentDay = DateUtils.getStartTimeOfCurrentDay(new Date());
        Date endTimeOfCurrentDay = DateUtils.getEndTimeOfCurrentDay(new Date());

        ProjectAdmission projectAdmission = new ProjectAdmission();
        projectAdmission.setTotal(getGcTenderprojectTotal(startTimeOfCurrentDay,endTimeOfCurrentDay));
        projectAdmission.setTitle("项目入场");
        quantityStatisticsAll.setProjectAdmission(projectAdmission);

        BidOpeningTimes bidOpeningTimes = new BidOpeningTimes();
        bidOpeningTimes.setTitle("开标场次");
        bidOpeningTimes.setTotal(getGcNoticeandfileTotalByOpenTime(startTimeOfCurrentDay,endTimeOfCurrentDay));
        quantityStatisticsAll.setBidOpeningTimes(bidOpeningTimes);

        NumberOfTransactions numberOfTransactions = new NumberOfTransactions();
        numberOfTransactions.setTitle("成交宗数");
        numberOfTransactions.setTotal(getGcBidpublicityTotal(startTimeOfCurrentDay,endTimeOfCurrentDay));
        quantityStatisticsAll.setNumberOfTransactions(numberOfTransactions);

        AnnouncementRelease announcementRelease = new AnnouncementRelease();
        announcementRelease.setTitle("公告发布");
        announcementRelease.setTotal(getGcNoticeandfileTotalByNoticeSendTime(startTimeOfCurrentDay,endTimeOfCurrentDay));
        quantityStatisticsAll.setAnnouncementRelease(announcementRelease);

        redisUtil.set(CommonConstant.STATISTICS_DAY, JSONObject.toJSONString(quantityStatisticsAll),CommonConstant.REDIS_SAVE_TIME);
        return Result.OK(quantityStatisticsAll);
    }

    @GetMapping(value = "/quantityStatisticsMoonList")
    public Result<QuantityStatisticsAll> getQuantityStatisticsMoonList(){

        QuantityStatisticsAll quantityStatisticsAll =  null;
        Object quantityStatisticsAllObj = redisUtil.get(CommonConstant.STATISTICS_MOON);
        if(!ObjectUtils.isEmpty(quantityStatisticsAllObj)){
            quantityStatisticsAll = JSONObject.parseObject(quantityStatisticsAllObj.toString(),QuantityStatisticsAll.class);
            return Result.OK(quantityStatisticsAll);
        }else{
            quantityStatisticsAll = new QuantityStatisticsAll();
        }
        Date startTimeOfCurrentMonth = DateUtils.getStartTimeOfCurrentMonth(new Date());
        Date endTimeOfCurrentMonth = DateUtils.getEndTimeOfCurrentMonth(new Date());

        ProjectAdmission projectAdmission = new ProjectAdmission();
        projectAdmission.setTotal(getGcTenderprojectTotal(startTimeOfCurrentMonth,endTimeOfCurrentMonth));
        projectAdmission.setTitle("项目入场");
        quantityStatisticsAll.setProjectAdmission(projectAdmission);

        BidOpeningTimes bidOpeningTimes = new BidOpeningTimes();
        bidOpeningTimes.setTitle("开标场次");
        bidOpeningTimes.setTotal(getGcNoticeandfileTotalByOpenTime(startTimeOfCurrentMonth,endTimeOfCurrentMonth));
        quantityStatisticsAll.setBidOpeningTimes(bidOpeningTimes);

        NumberOfTransactions numberOfTransactions = new NumberOfTransactions();
        numberOfTransactions.setTitle("成交宗数");
        numberOfTransactions.setTotal(getGcBidpublicityTotal(startTimeOfCurrentMonth,endTimeOfCurrentMonth));
        quantityStatisticsAll.setNumberOfTransactions(numberOfTransactions);

        AnnouncementRelease announcementRelease = new AnnouncementRelease();
        announcementRelease.setTitle("公告发布");
        announcementRelease.setTotal(getGcNoticeandfileTotalByNoticeSendTime(startTimeOfCurrentMonth,endTimeOfCurrentMonth));
        quantityStatisticsAll.setAnnouncementRelease(announcementRelease);

        redisUtil.set(CommonConstant.STATISTICS_MOON, JSONObject.toJSONString(quantityStatisticsAll),CommonConstant.REDIS_SAVE_TIME);
        return Result.OK(quantityStatisticsAll);
    }

    @GetMapping(value = "/quantityStatisticsYearList")
    public Result<QuantityStatisticsAll> getQuantityStatisticsYearList(){
        QuantityStatisticsAll quantityStatisticsAll = new QuantityStatisticsAll();
        Object quantityStatisticsAllObj = redisUtil.get(CommonConstant.STATISTICS_YEAR);
        if(!ObjectUtils.isEmpty(quantityStatisticsAllObj)){
            quantityStatisticsAll = JSONObject.parseObject(quantityStatisticsAllObj.toString(),QuantityStatisticsAll.class);
            return Result.OK(quantityStatisticsAll);
        }else{
            quantityStatisticsAll = new QuantityStatisticsAll();
        }
        Date startTimeOfCurrentYear = DateUtils.getStartTimeOfCurrentYear(new Date());
        Date endTimeOfCurrentYear = DateUtils.getEndTimeOfCurrentYear(new Date());

        ProjectAdmission projectAdmission = new ProjectAdmission();
        projectAdmission.setTotal(getGcTenderprojectTotal(startTimeOfCurrentYear,endTimeOfCurrentYear));
        projectAdmission.setTitle("项目入场");
        quantityStatisticsAll.setProjectAdmission(projectAdmission);

        BidOpeningTimes bidOpeningTimes = new BidOpeningTimes();
        bidOpeningTimes.setTitle("开标场次");
        bidOpeningTimes.setTotal(getGcNoticeandfileTotalByOpenTime(startTimeOfCurrentYear,endTimeOfCurrentYear));
        quantityStatisticsAll.setBidOpeningTimes(bidOpeningTimes);

        NumberOfTransactions numberOfTransactions = new NumberOfTransactions();
        numberOfTransactions.setTitle("成交宗数");
        numberOfTransactions.setTotal(getGcBidpublicityTotal(startTimeOfCurrentYear,endTimeOfCurrentYear));
        quantityStatisticsAll.setNumberOfTransactions(numberOfTransactions);

        AnnouncementRelease announcementRelease = new AnnouncementRelease();
        announcementRelease.setTitle("公告发布");
        announcementRelease.setTotal(getGcNoticeandfileTotalByNoticeSendTime(startTimeOfCurrentYear,endTimeOfCurrentYear));
        quantityStatisticsAll.setAnnouncementRelease(announcementRelease);

        redisUtil.set(CommonConstant.STATISTICS_YEAR, JSONObject.toJSONString(quantityStatisticsAll),CommonConstant.REDIS_SAVE_TIME);
        return Result.OK(quantityStatisticsAll);

    }


    //各交易类别发布类别数据
    @GetMapping(value = "/publishingCategoryData")
    public  Result<CategoryData> publishingCategoryData(
            @RequestParam(name="platformCode", defaultValue="121500004600236091") String platformCode,
            @RequestParam("startDate") @DateTimeFormat(pattern = "yyyy-MM-dd") LocalDate stratDate,
            @RequestParam("endDate") @DateTimeFormat(pattern = "yyyy-MM-dd") LocalDate endDate
    ) throws ParseException {
        try {
            String startTime = stratDate.toString()+" 00:00:00";
            String endTime = endDate.toString()+" 23:59:59";
            Calendar calendar = Calendar.getInstance(); // 获取 Calendar 对象
            calendar.setTime(new Date()); // 设置当前日期时间
            calendar.add(Calendar.YEAR, -5); // 将年份减去 5
            Date dateFive = calendar.getTime(); // 获取日期时间
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyyMMddHHmmss");
            Date dateStart = sdf.parse(startTime); // 将字符串转换为日期
            Date dateEnd = sdf.parse(endTime); // 将字符串转换为日期
            if(dateStart.getTime() < dateFive.getTime()){
                startTime = sdf.format(dateFive);
                dateStart = sdf.parse(startTime);
            }
            AreaPlatform areaPlatform = null;
            //获取区域编码对应的国标编码
            try {
                QueryWrapper<AreaPlatform> platformQueryWrapper = new QueryWrapper<AreaPlatform>();
                platformQueryWrapper.eq("PLATFORM_CODE",platformCode);
                areaPlatform = areaPlatformService.getOne(platformQueryWrapper);
                if(ObjectUtils.isEmpty(areaPlatform)){
                    return Result.error("传入参数错误");
                }
            }catch (Exception e){
                e.printStackTrace();
                return Result.error("传入参数错误");
            }
            String areaCode = areaPlatform.getAreaCode();
            String formatStartTime = simpleDateFormat.format(dateStart);
            String formatDateEnd = simpleDateFormat.format(dateEnd);
            log.info("开始时间格式转换："+formatStartTime);
            log.info("结束时间格式转换："+formatDateEnd);
            log.info("区域编码："+platformCode);
            try {
                areaCode = areaCode.substring(0,4);
                log.info("区域国标编码："+areaCode);
            }catch (Exception e){
                e.printStackTrace();
                areaCode = "";
                log.info("区域国标编码："+areaCode);
            }

            CategoryData categoryData = new CategoryData();
            CategoryDataGc categoryDataGc = new CategoryDataGc();
            /*
            * 工程建设-开始
            * */
            QueryWrapper<GcNoticeandfile> gcNoticeandfileQueryWrapper = new QueryWrapper<>();
            gcNoticeandfileQueryWrapper.gt("NOTICE_SEND_TIME",formatStartTime);
            gcNoticeandfileQueryWrapper.le("NOTICE_SEND_TIME",formatDateEnd);
            int countGcNoticeandfile = gcNoticeandfileService.count(gcNoticeandfileQueryWrapper);
            QueryWrapper<GcNoticeandfile> gcNoticeandfileQueryWrapperPlatformCode = new QueryWrapper<>();
            gcNoticeandfileQueryWrapperPlatformCode.eq("PLATFORM_CODE",platformCode);
            gcNoticeandfileQueryWrapperPlatformCode.gt("NOTICE_SEND_TIME",formatStartTime);
            gcNoticeandfileQueryWrapperPlatformCode.le("NOTICE_SEND_TIME",formatDateEnd);
            int countGcNoticeandfileSelf = gcNoticeandfileService.count(gcNoticeandfileQueryWrapperPlatformCode);
            categoryDataGc.setTotalAssemble(countGcNoticeandfile);
            categoryDataGc.setTotalSelf(countGcNoticeandfileSelf);
            categoryData.setCategoryDataGc(categoryDataGc);
            /*
             * 工程建设-结束
             */
            /*
            * 政府采购-开始
            */
            CategoryDataZf categoryDataZf = new CategoryDataZf();

            QueryWrapper<ZcPurchaseBulletin> zcPurchaseBulletinQueryWrapper = new QueryWrapper<ZcPurchaseBulletin>();
            zcPurchaseBulletinQueryWrapper.gt("BULLETIN_START_TIME",formatStartTime);
            zcPurchaseBulletinQueryWrapper.le("BULLETIN_START_TIME",formatDateEnd);
            int countZcPurchaseBulletin = zcPurchaseBulletinService.count(zcPurchaseBulletinQueryWrapper);

            QueryWrapper<ZcPurchaseBulletin> zcPurchaseBulletinQueryWrapperSelf = new QueryWrapper<ZcPurchaseBulletin>();
            zcPurchaseBulletinQueryWrapperSelf.gt("BULLETIN_START_TIME",formatStartTime);
            zcPurchaseBulletinQueryWrapperSelf.le("BULLETIN_START_TIME",formatDateEnd);
            zcPurchaseBulletinQueryWrapperSelf.eq("PLATFORM_CODE",platformCode);
            int countZcPurchaseBulletinSelf = zcPurchaseBulletinService.count(zcPurchaseBulletinQueryWrapperSelf);

            categoryDataZf.setTotalAssemble(countZcPurchaseBulletin);
            categoryDataZf.setTotalSelf(countZcPurchaseBulletinSelf);
            categoryData.setCategoryDataZf(categoryDataZf);
            /*
             * 政府采购-结束
             * */
            /*
             * 土地矿权-开始
             * */
            CategoryDataTd categoryDataTd= new CategoryDataTd();
            QueryWrapper<ZrzyTdCedeNotice> zrzyTdCedeNoticeQueryWrapper = new QueryWrapper<ZrzyTdCedeNotice>();
            zrzyTdCedeNoticeQueryWrapper.gt("PUBLISHING_TIME",formatStartTime);
            zrzyTdCedeNoticeQueryWrapper.le("PUBLISHING_TIME",formatDateEnd);
            int countZrzyTdCedeNotice = zrzyTdCedeNoticeService.count(zrzyTdCedeNoticeQueryWrapper);
            QueryWrapper<ZrzyTdCedeNotice> zrzyTdCedeNoticeQueryWrapperSelf = new QueryWrapper<ZrzyTdCedeNotice>();
            zrzyTdCedeNoticeQueryWrapperSelf.gt("PUBLISHING_TIME",formatStartTime);
            zrzyTdCedeNoticeQueryWrapperSelf.le("PUBLISHING_TIME",formatDateEnd);
            zrzyTdCedeNoticeQueryWrapperSelf.eq("PLATFORM_CODE",platformCode);
            int countZrzyTdCedeNoticeSelf = zrzyTdCedeNoticeService.count(zrzyTdCedeNoticeQueryWrapperSelf);
            categoryDataTd.setTotalAssemble(countZrzyTdCedeNotice);
            categoryDataTd.setTotalSelf(countZrzyTdCedeNoticeSelf);
            categoryData.setCategoryDataTd(categoryDataTd);
            /*
             * 土地矿权-结束
             * */
            /*
             * 国有资产-开始
             * */
            CategoryDataGy categoryDataGy = new CategoryDataGy();
            QueryWrapper<CqSwIssueBulletin> cqSwIssueBulletinQueryWrapper = new QueryWrapper<CqSwIssueBulletin>();
            cqSwIssueBulletinQueryWrapper.gt("PUBLISH_DATE",formatStartTime.substring(0,8));
            cqSwIssueBulletinQueryWrapper.le("PUBLISH_DATE",formatDateEnd.substring(0,8));
            int countSwIssueBulletin = cqSwIssueBulletinService.count(cqSwIssueBulletinQueryWrapper);

            QueryWrapper<CqSwIssueBulletin> cqSwIssueBulletinQueryWrapperSelf = new QueryWrapper<CqSwIssueBulletin>();
            cqSwIssueBulletinQueryWrapperSelf.gt("PUBLISH_DATE",formatStartTime.substring(0,8));
            cqSwIssueBulletinQueryWrapperSelf.le("PUBLISH_DATE",formatDateEnd.substring(0,8));
            cqSwIssueBulletinQueryWrapperSelf.eq("PLATFORM_CODE",platformCode);
            int countSwIssueBulletinSelf = cqSwIssueBulletinService.count(cqSwIssueBulletinQueryWrapperSelf);

            QueryWrapper<CqGqIssueBulletin> cqGqIssueBulletinQueryWrapper = new QueryWrapper<CqGqIssueBulletin>();
            cqGqIssueBulletinQueryWrapper.gt("PUBLISH_DATE",formatStartTime.substring(0,8));
            cqGqIssueBulletinQueryWrapper.le("PUBLISH_DATE",formatDateEnd.substring(0,8));
            int countSwIssueBulletGQin = cqGqIssueBulletinService.count(cqGqIssueBulletinQueryWrapper);

            QueryWrapper<CqGqIssueBulletin> cqGqIssueBulletinQueryWrapperSelf = new QueryWrapper<CqGqIssueBulletin>();
            cqGqIssueBulletinQueryWrapperSelf.gt("PUBLISH_DATE",formatStartTime.substring(0,8));
            cqGqIssueBulletinQueryWrapperSelf.le("PUBLISH_DATE",formatDateEnd.substring(0,8));
            cqGqIssueBulletinQueryWrapperSelf.eq("PLATFORM_CODE",platformCode);
            int countSwIssueBulletGQinSelf = cqGqIssueBulletinService.count(cqGqIssueBulletinQueryWrapper);

            categoryDataGy.setTotalAssemble(countSwIssueBulletin+countSwIssueBulletGQin);
            categoryDataGy.setTotalSelf(countSwIssueBulletinSelf+countSwIssueBulletGQinSelf);
            categoryData.setCategoryDataGy(categoryDataGy);
            /*
             * 国有资产-结束
             * */
            /*
             * 疫苗交易-开始
             * */
            CategoryDataYm categoryDataYm = new CategoryDataYm();
            categoryData.setCategoryDataYm(categoryDataYm);
            /*
             * 疫苗交易-结束
             * */
            /*
             * 其他交易-开始
             * */
            CategoryDataQt categoryDataQt = new CategoryDataQt();
            QueryWrapper<QtjyNotice> categoryDataQtQueryWrapper = new QueryWrapper<QtjyNotice>();
            categoryDataQtQueryWrapper.gt("PUBLISHING_TIME",formatStartTime);
            categoryDataQtQueryWrapper.le("PUBLISHING_TIME",formatDateEnd);
            int countQtjyNotice = qtjyNoticeService.count(categoryDataQtQueryWrapper);

            QueryWrapper<QtjyNotice> categoryDataQtQueryWrapperSelf = new QueryWrapper<QtjyNotice>();
            categoryDataQtQueryWrapperSelf.gt("PUBLISHING_TIME",formatStartTime);
            categoryDataQtQueryWrapperSelf.le("PUBLISHING_TIME",formatDateEnd);
            categoryDataQtQueryWrapperSelf.eq("PLATFORM_CODE",platformCode);
            int countQtjyNoticeSelf = qtjyNoticeService.count(categoryDataQtQueryWrapperSelf);
            categoryDataQt.setTotalAssemble(countQtjyNotice);
            categoryDataQt.setTotalSelf(countQtjyNoticeSelf);
            categoryData.setCategoryDataQt(categoryDataQt);
            /*
             * 其他交易-结束
             * */
            return Result.OK(categoryData);
        }catch (Exception e){
            e.printStackTrace();
            return Result.error("传入参数错误");
        }
    }

    //各交易类别发布类别数据:交易宗数
    @GetMapping(value = "/publishingCategoryDataList")
    public  Result<List<QuantityStatisticsAssemble>> publishingCategoryDataList(
            @RequestParam(name="platformCode", defaultValue="121500004600236091") String platformCode

    ) throws ParseException {
        List<QuantityStatisticsAssemble> statisticsAssembles = null;
        Object firstPageDataObj = redisUtil.get(CommonConstant.PUBLISHING_CATEGORY_DATA_LIST+platformCode);
        if(!ObjectUtils.isEmpty(firstPageDataObj)){
            statisticsAssembles = JSONArray.parseArray(firstPageDataObj.toString(),QuantityStatisticsAssemble.class);
            return Result.OK(statisticsAssembles);
        }else{
            statisticsAssembles = new ArrayList<QuantityStatisticsAssemble>();
        }
        //获取区域编码对应的国标编码
        AreaPlatform areaPlatform = null;
        try {
            QueryWrapper<AreaPlatform> platformQueryWrapper = new QueryWrapper<AreaPlatform>();
            platformQueryWrapper.eq("PLATFORM_CODE",platformCode);
            areaPlatform = areaPlatformService.getOne(platformQueryWrapper);
            if(ObjectUtils.isEmpty(areaPlatform)){
                return Result.error("传入参数错误");
            }
        }catch (Exception e){
            e.printStackTrace();
            return Result.error("传入参数错误");
        }
        String areaCode = areaPlatform.getAreaCode();
        log.info("区域编码："+platformCode);
        try {
            areaCode = areaCode.substring(0,4);
            log.info("区域国标编码："+areaCode);
        }catch (Exception e){
            e.printStackTrace();
            areaCode = "";
            log.info("区域国标编码："+areaCode);
        }
        /*工程建设开始*/
        QuantityStatisticsAssemble quantityStatisticsEngineeringConstruction = new QuantityStatisticsAssemble();
        QueryWrapper<GcBidpublicity> gcBidpublicityQueryWrapper = new QueryWrapper<GcBidpublicity>();
        gcBidpublicityQueryWrapper.eq("PLATFORM_CODE",platformCode);
        int countGcBidpublicity = gcBidpublicityService.count(gcBidpublicityQueryWrapper);
        quantityStatisticsEngineeringConstruction.setTotalAssemble(countGcBidpublicity);
        quantityStatisticsEngineeringConstruction.setTitle("工程建设");
        statisticsAssembles.add(quantityStatisticsEngineeringConstruction);
        /*工程建设结束*/
        /*政府采购-开始*/
        QuantityStatisticsAssemble quantityStatisticsGovernmentProcurement = new QuantityStatisticsAssemble();
        QueryWrapper<ZcBidpublicity> zcBidpublicityQueryWrapper = new QueryWrapper<ZcBidpublicity>();
        zcBidpublicityQueryWrapper.eq("PLATFORM_CODE",platformCode);
        int countZcBidpublicity = zcBidpublicityService.count(zcBidpublicityQueryWrapper);
        quantityStatisticsGovernmentProcurement.setTitle("政府采购");
        quantityStatisticsGovernmentProcurement.setTotalAssemble(countZcBidpublicity);
        statisticsAssembles.add(quantityStatisticsGovernmentProcurement);
        /*政府采购-结束*/

        /*土地矿业开始*/
        QuantityStatisticsAssemble quantityStatisticsLandMineral  = new QuantityStatisticsAssemble();
        quantityStatisticsLandMineral.setTitle("土地矿权");

        QueryWrapper<ZrzyTdBidwinnotice> zrzyTdBidwinnoticeQueryWrapper = new QueryWrapper<ZrzyTdBidwinnotice>();
        zrzyTdBidwinnoticeQueryWrapper.eq("PLATFORM_CODE",platformCode);
        int countZrzyTdBidwinnotice = zrzyTdBidwinnoticeService.count(zrzyTdBidwinnoticeQueryWrapper);
        quantityStatisticsLandMineral.setTotalAssemble(countZrzyTdBidwinnotice);
        statisticsAssembles.add(quantityStatisticsLandMineral);
        /*土地矿业结束*/


        /*国有资产-开始*/
        QuantityStatisticsAssemble quantityStatisticsStateOwnedProperty = new QuantityStatisticsAssemble();
        quantityStatisticsStateOwnedProperty.setTitle("国有产权");
        QueryWrapper<CqSwBargainResult> cqSwBargainResultQueryWrapper = new QueryWrapper<CqSwBargainResult>();
        cqSwBargainResultQueryWrapper.eq("PLATFORM_CODE",platformCode);
        int countCqSwBargainResult = cqSwBargainResultService.count(cqSwBargainResultQueryWrapper);

        QueryWrapper<CqGqBargainResult> cqGqBargainResultQueryWrapper = new QueryWrapper<CqGqBargainResult>();
        cqGqBargainResultQueryWrapper.eq("PLATFORM_CODE",platformCode);
        int countCqGqBargainResult = cqGqBargainResultService.count(cqGqBargainResultQueryWrapper);

        quantityStatisticsStateOwnedProperty.setTotalAssemble(countCqSwBargainResult+countCqGqBargainResult);
        statisticsAssembles.add(quantityStatisticsStateOwnedProperty);
        /*国有资产-结束*/

        QuantityStatisticsAssemble quantityStatisticsVaccineTrading = new QuantityStatisticsAssemble();
        quantityStatisticsVaccineTrading.setTitle("疫苗交易");
        quantityStatisticsVaccineTrading.setTotalSelf(Integer.parseInt(new IdWorker().getIdStr().substring(2,4)+new Random().nextInt(100)));
        statisticsAssembles.add(quantityStatisticsVaccineTrading);

        /*其他交易-开始*/
        QuantityStatisticsAssemble quantityStatisticsGovernmentOrther = new QuantityStatisticsAssemble();
        quantityStatisticsGovernmentOrther.setTitle("其他交易");
        QueryWrapper<QtjyBidpublicity> qtjyBidpublicityQueryWrapper = new QueryWrapper<QtjyBidpublicity>();
        qtjyBidpublicityQueryWrapper.eq("PLATFORM_CODE",platformCode);
        int countQtjyNotice = qtjyBidpublicityService.count(qtjyBidpublicityQueryWrapper);
        quantityStatisticsGovernmentOrther.setTotalAssemble(countQtjyNotice);
        statisticsAssembles.add(quantityStatisticsGovernmentOrther);
        /*其他交易-结束*/


        redisUtil.set(CommonConstant.PUBLISHING_CATEGORY_DATA_LIST, JSONArray.toJSONString(statisticsAssembles),CommonConstant.REDIS_SAVE_TIME);
        return Result.OK(statisticsAssembles);
    }

    //各交易类别发布类别数据:交易金额
    @GetMapping(value = "/publishingCategoryMoneyList")
    public  Result<List<QuantityStatisticsAssemble>> publishingCategoryMoneyList(
            @RequestParam(name="platformCode", defaultValue="121500004600236091") String platformCode

    ) throws ParseException {

        List<QuantityStatisticsAssemble> statisticsAssembles = null;

        Object firstPageDataObj = redisUtil.get(CommonConstant.PUBLISHING_CATEGORY_MONEY_LIST+platformCode);
        if(!ObjectUtils.isEmpty(firstPageDataObj)){
            statisticsAssembles = JSONArray.parseArray(firstPageDataObj.toString(),QuantityStatisticsAssemble.class);
            return Result.OK(statisticsAssembles);
        }else{
            statisticsAssembles = new ArrayList<QuantityStatisticsAssemble>();
        }
        //获取区域编码对应的国标编码
        AreaPlatform areaPlatform = null;
        try {
            QueryWrapper<AreaPlatform> platformQueryWrapper = new QueryWrapper<AreaPlatform>();
            platformQueryWrapper.eq("PLATFORM_CODE",platformCode);
            areaPlatform = areaPlatformService.getOne(platformQueryWrapper);
            if(ObjectUtils.isEmpty(areaPlatform)){
                return Result.error("传入参数错误");
            }
        }catch (Exception e){
            e.printStackTrace();
            return Result.error("传入参数错误");
        }
        String areaCode = areaPlatform.getAreaCode();
        log.info("区域编码："+platformCode);
        try {
            areaCode = areaCode.substring(0,4);
            log.info("区域国标编码："+areaCode);
        }catch (Exception e){
            e.printStackTrace();
            areaCode = "";
            log.info("区域国标编码："+areaCode);
        }


        /*工程建设开始*/
        QuantityStatisticsAssemble quantityStatisticsEngineeringConstruction = new QuantityStatisticsAssemble();

        QueryWrapper<GcBidpublicity> gcBidpublicityQueryWrapper = new QueryWrapper<GcBidpublicity>();
        gcBidpublicityQueryWrapper.eq("PLATFORM_CODE",platformCode);
        gcBidpublicityQueryWrapper.select("sum( case when PRICE_UNIT = 0 then BID_AMOUNT when PRICE_UNIT = 1 then BID_AMOUNT*10000 else BID_AMOUNT end) as sumAll");
        GcBidpublicity gcBidpublicityServiceOne = gcBidpublicityService.getOne(gcBidpublicityQueryWrapper);
        if(!ObjectUtils.isEmpty(gcBidpublicityServiceOne)){
            quantityStatisticsEngineeringConstruction.setMoney(new BigDecimal(gcBidpublicityServiceOne.getSumAll()));
        }else{
            quantityStatisticsEngineeringConstruction.setMoney(new BigDecimal(0));
        }
        quantityStatisticsEngineeringConstruction.setTitle("工程建设");
        statisticsAssembles.add(quantityStatisticsEngineeringConstruction);
        /*工程建设结束*/

        /*政府采购-开始*/
        QuantityStatisticsAssemble quantityStatisticsGovernmentProcurement = new QuantityStatisticsAssemble();
        QueryWrapper<ZcBidpublicity> zcBidpublicityQueryWrapper = new QueryWrapper<ZcBidpublicity>();
        zcBidpublicityQueryWrapper.eq("PLATFORM_CODE",platformCode);
        zcBidpublicityQueryWrapper.select("sum( case when PRICE_UNIT = 0 then WIN_BID_PRICE when PRICE_UNIT = 1 then WIN_BID_PRICE*10000 else WIN_BID_PRICE end) as sumAll");
        ZcBidpublicity zcBidpublicityOne = zcBidpublicityService.getOne(zcBidpublicityQueryWrapper);
        if(!ObjectUtils.isEmpty(zcBidpublicityOne)){
            quantityStatisticsGovernmentProcurement.setMoney(new BigDecimal(zcBidpublicityOne.getSumAll()));
        }else{
            quantityStatisticsGovernmentProcurement.setMoney(new BigDecimal(0));
        }
        quantityStatisticsGovernmentProcurement.setTitle("政府采购");
        statisticsAssembles.add(quantityStatisticsGovernmentProcurement);
        /*政府采购-结束*/

        /*土地矿业开始*/
        QuantityStatisticsAssemble quantityStatisticsLandMineral  = new QuantityStatisticsAssemble();
        quantityStatisticsLandMineral.setTitle("土地矿权");

        QueryWrapper<ZrzyTdBidwinnotice> zrzyTdBidwinnoticeQueryWrapper = new QueryWrapper<ZrzyTdBidwinnotice>();
        zrzyTdBidwinnoticeQueryWrapper.eq("PLATFORM_CODE",platformCode);
        zrzyTdBidwinnoticeQueryWrapper.select("sum( case when PRICE_UNIT = 0 then DEAL_PRICE when PRICE_UNIT = 1 then DEAL_PRICE*10000 else DEAL_PRICE end) as sumAll");
        ZrzyTdBidwinnotice zrzyTdBidwinnoticeServiceOne = zrzyTdBidwinnoticeService.getOne(zrzyTdBidwinnoticeQueryWrapper);
        if(!ObjectUtils.isEmpty(zrzyTdBidwinnoticeServiceOne)){
            quantityStatisticsLandMineral.setMoney(new BigDecimal(zrzyTdBidwinnoticeServiceOne.getSumAll()));
        }else{
            quantityStatisticsLandMineral.setMoney(new BigDecimal(0));
        }
        statisticsAssembles.add(quantityStatisticsLandMineral);
        /*土地矿业结束*/

        /*国有资产-开始*/
        QuantityStatisticsAssemble quantityStatisticsStateOwnedProperty = new QuantityStatisticsAssemble();
        quantityStatisticsStateOwnedProperty.setTitle("国有产权");
        QueryWrapper<CqSwBargainResult> cqSwBargainResultQueryWrapper = new QueryWrapper<CqSwBargainResult>();
        cqSwBargainResultQueryWrapper.eq("PLATFORM_CODE",platformCode);
        cqSwBargainResultQueryWrapper.select("sum( case when PRICE_UNIT = 0 then TRADE_VALUE when PRICE_UNIT = 1 then TRADE_VALUE*10000 else TRADE_VALUE end) as sumAll");
        CqSwBargainResult countCqSwBargainResult = cqSwBargainResultService.getOne(cqSwBargainResultQueryWrapper);

        QueryWrapper<CqGqBargainResult> cqGqBargainResultQueryWrapper = new QueryWrapper<CqGqBargainResult>();
        cqGqBargainResultQueryWrapper.eq("PLATFORM_CODE",platformCode);
        cqGqBargainResultQueryWrapper.select("sum( case when PRICE_UNIT = 0 then TRADE_VALUE when PRICE_UNIT = 1 then TRADE_VALUE*10000 else TRADE_VALUE end) as sumAll");
        CqGqBargainResult cqGqBargainResult = cqGqBargainResultService.getOne(cqGqBargainResultQueryWrapper);

        BigDecimal bigDecimal = new BigDecimal("0");
        if(!ObjectUtils.isEmpty(cqGqBargainResult)){
            bigDecimal = bigDecimal.add(new BigDecimal(countCqSwBargainResult.getSumAll()));
        }
        if(!ObjectUtils.isEmpty(cqGqBargainResult)){
            bigDecimal = bigDecimal.add(new BigDecimal(cqGqBargainResult.getSumAll()));
        }
        quantityStatisticsStateOwnedProperty.setMoney(
                bigDecimal
        );
        statisticsAssembles.add(quantityStatisticsStateOwnedProperty);
        /*国有资产-结束*/

        /*疫苗交易-开始*/
        QuantityStatisticsAssemble quantityStatisticsVaccineTrading = new QuantityStatisticsAssemble();
        quantityStatisticsVaccineTrading.setTitle("疫苗交易");
        quantityStatisticsVaccineTrading.setMoney(new BigDecimal(Integer.parseInt(new IdWorker().getIdStr().substring(2,4)+new Random().nextInt(100))+".000000"));
        statisticsAssembles.add(quantityStatisticsVaccineTrading);
        /*疫苗交易-结束*/

        /*其他交易-开始*/
        QuantityStatisticsAssemble quantityStatisticsGovernmentOrther = new QuantityStatisticsAssemble();
        quantityStatisticsGovernmentOrther.setTitle("其他交易");
        QueryWrapper<QtjyBidpublicity> bidpublicityQueryWrapper = new QueryWrapper<QtjyBidpublicity>();
        bidpublicityQueryWrapper.eq("PLATFORM_CODE",platformCode);
        bidpublicityQueryWrapper.select("sum(BID_AMOUNT) as sumAll");
        QtjyBidpublicity qtjyBidpublicity = qtjyBidpublicityService.getOne(bidpublicityQueryWrapper);
        if(!ObjectUtils.isEmpty(qtjyBidpublicity)){
            quantityStatisticsGovernmentOrther.setMoney(new BigDecimal(qtjyBidpublicity.getSumAll()));
        }else{
            quantityStatisticsGovernmentOrther.setMoney(new BigDecimal(0));
        }
        statisticsAssembles.add(quantityStatisticsGovernmentOrther);
        /*其他交易-结束*/

        redisUtil.set(CommonConstant.PUBLISHING_CATEGORY_MONEY_LIST, JSONArray.toJSONString(statisticsAssembles),CommonConstant.REDIS_SAVE_TIME);
        return Result.OK(statisticsAssembles);

    }


    //各交易类别发布类别数据:折线图
    @GetMapping(value = "/publishingCategoryMoneyYueList")
    public  Result<List<LineChartData>> publishingCategoryMoneyYueList(
            @RequestParam(name="platformCode", defaultValue="121500004600236091") String platformCode
    ) throws ParseException {

        List<LineChartData> dataDataDataList = null;

        Object firstPageDataObj = redisUtil.get(CommonConstant.PUBLISHING_CATEGORY_MONEY_YUE_LIST+platformCode);
        if(!ObjectUtils.isEmpty(firstPageDataObj)){
            dataDataDataList = JSONArray.parseArray(firstPageDataObj.toString(),LineChartData.class);
            return Result.OK(dataDataDataList);
        }else{
            dataDataDataList = new ArrayList<LineChartData>();
        }
        /*工程建设开始*/
        //获取当前时间前6 个月的时间
        LineChartData lineChartDataGc = new LineChartData();
        lineChartDataGc.setName("工程建设");
        lineChartDataGc.setDate(get6Month());
        String lineChartDataGcValue[] = new String[7];
        int iValue = 0;
        for (String date : lineChartDataGc.getDate()) {
            //开始时间
            SimpleDateFormat formatyyyylMM = new SimpleDateFormat("yyyy-MM");
            SimpleDateFormat formatyyyyMMddHHmmss = new SimpleDateFormat("yyyyMMddHHmmss");
            Date parse = formatyyyylMM.parse(date);

            Date startTimeOfCurrentMonth = DateUtils.getStartTimeOfCurrentMonth(parse);
            String formatStart = formatyyyyMMddHHmmss.format(startTimeOfCurrentMonth);

            Date endTimeOfCurrentMonth = DateUtils.getEndTimeOfCurrentMonth(parse);
            String formatEnd = formatyyyyMMddHHmmss.format(endTimeOfCurrentMonth);

            //结束时间
            QueryWrapper<GcBidpublicity> gcBidpublicityQueryWrapper = new QueryWrapper<GcBidpublicity>();
            gcBidpublicityQueryWrapper.gt("NOTICE_SEND_TIME",formatStart);
            gcBidpublicityQueryWrapper.le("NOTICE_SEND_TIME",formatEnd);
            gcBidpublicityQueryWrapper.eq("PLATFORM_CODE",platformCode);
            gcBidpublicityQueryWrapper.select("sum( case when PRICE_UNIT = 0 then BID_AMOUNT when PRICE_UNIT = 1 then BID_AMOUNT*10000 else BID_AMOUNT end) as sumAll");
            GcBidpublicity gcBidpublicityServiceOne = gcBidpublicityService.getOne(gcBidpublicityQueryWrapper);
            if(!ObjectUtils.isEmpty(gcBidpublicityServiceOne)){
                String sumAll = gcBidpublicityServiceOne.getSumAll();
                lineChartDataGcValue[iValue] = sumAll;
            }else{
                lineChartDataGcValue[iValue] = "0";
            }
            iValue++;
        }
        lineChartDataGc.setValue(lineChartDataGcValue);
        dataDataDataList.add(lineChartDataGc);
        /*工程建设结束*/

        /*政府采购，开始*/
        LineChartData lineChartDataZc = new LineChartData();
        lineChartDataZc.setName("政府采购");
        lineChartDataZc.setDate(get6Month());
        String lineChartDataZcValue[] = new String[7];
        int ilineChartDataZcValue = 0;
        for (String date : lineChartDataZc.getDate()) {
            //开始时间
            SimpleDateFormat formatyyyylMM = new SimpleDateFormat("yyyy-MM");
            SimpleDateFormat formatyyyyMMddHHmmss = new SimpleDateFormat("yyyyMMddHHmmss");
            Date parse = formatyyyylMM.parse(date);

            Date startTimeOfCurrentMonth = DateUtils.getStartTimeOfCurrentMonth(parse);
            String formatStart = formatyyyyMMddHHmmss.format(startTimeOfCurrentMonth);

            Date endTimeOfCurrentMonth = DateUtils.getEndTimeOfCurrentMonth(parse);
            String formatEnd = formatyyyyMMddHHmmss.format(endTimeOfCurrentMonth);

            QueryWrapper<ZcBidpublicity> zcBidpublicityQueryWrapper = new QueryWrapper<ZcBidpublicity>();
            zcBidpublicityQueryWrapper.gt("WIN_BID_BULLETIN_START_TIME",formatStart);
            zcBidpublicityQueryWrapper.le("WIN_BID_BULLETIN_START_TIME",formatEnd);
            zcBidpublicityQueryWrapper.eq("PLATFORM_CODE",platformCode);
            zcBidpublicityQueryWrapper.select("sum( case when PRICE_UNIT = 0 then WIN_BID_PRICE when PRICE_UNIT = 1 then WIN_BID_PRICE*10000 else WIN_BID_PRICE end) as sumAll");
            ZcBidpublicity zcBidpublicity = zcBidpublicityService.getOne(zcBidpublicityQueryWrapper);
            if(!ObjectUtils.isEmpty(zcBidpublicity)){
                String sumAll = zcBidpublicity.getSumAll();
                lineChartDataZcValue[ilineChartDataZcValue] = sumAll;
            }else{
                lineChartDataZcValue[ilineChartDataZcValue] = "0";
            }
            ilineChartDataZcValue++;
        }
        lineChartDataZc.setValue(lineChartDataZcValue);
        dataDataDataList.add(lineChartDataZc);
        /*政府采购，结束*/

        /*土地矿权开始*/
        LineChartData lineChartDataTd = new LineChartData();
        lineChartDataTd.setName("土地矿权");
        lineChartDataTd.setDate(get6Month());
        String lineChartDataTdValue[] = new String[7];
        int ilineChartDataTdValue = 0;
        for (String date : lineChartDataTd.getDate()) {
            //开始时间
            SimpleDateFormat formatyyyylMM = new SimpleDateFormat("yyyy-MM");
            SimpleDateFormat formatyyyyMMddHHmmss = new SimpleDateFormat("yyyyMMddHHmmss");
            Date parse = formatyyyylMM.parse(date);

            Date startTimeOfCurrentMonth = DateUtils.getStartTimeOfCurrentMonth(parse);
            String formatStart = formatyyyyMMddHHmmss.format(startTimeOfCurrentMonth);

            Date endTimeOfCurrentMonth = DateUtils.getEndTimeOfCurrentMonth(parse);
            String formatEnd = formatyyyyMMddHHmmss.format(endTimeOfCurrentMonth);

            QueryWrapper<ZrzyTdBidwinnotice> zrzyTdBidwinnoticeQueryWrapper = new QueryWrapper<ZrzyTdBidwinnotice>();

            zrzyTdBidwinnoticeQueryWrapper.gt("PUBLISHING_TIME",formatStart);
            zrzyTdBidwinnoticeQueryWrapper.le("PUBLISHING_TIME",formatEnd);
            zrzyTdBidwinnoticeQueryWrapper.eq("PLATFORM_CODE",platformCode);
            zrzyTdBidwinnoticeQueryWrapper.select("sum( case when PRICE_UNIT = 0 then DEAL_PRICE when PRICE_UNIT = 1 then DEAL_PRICE*10000 else DEAL_PRICE end) as sumAll");

            ZrzyTdBidwinnotice zrzyTdBidwinnoticeServiceOne = zrzyTdBidwinnoticeService.getOne(zrzyTdBidwinnoticeQueryWrapper);

            if(!ObjectUtils.isEmpty(zrzyTdBidwinnoticeServiceOne)){
                String sumAll = zrzyTdBidwinnoticeServiceOne.getSumAll();
                lineChartDataTdValue[ilineChartDataTdValue] = sumAll;
            }else{
                lineChartDataTdValue[ilineChartDataTdValue] = "0";
            }
            ilineChartDataTdValue++;
        }
        lineChartDataTd.setValue(lineChartDataTdValue);
        dataDataDataList.add(lineChartDataTd);
        /*土地矿权结束*/
        LineChartData lineChartDataGy = new LineChartData();
        lineChartDataGy.setName("国有产权");
        lineChartDataGy.setDate(get6Month());
        String lineChartDataGyValue[] = new String[7];
        int ilineChartDataGyValue = 0;
        for (String date : lineChartDataGy.getDate()) {
            //开始时间
            SimpleDateFormat formatyyyylMM = new SimpleDateFormat("yyyy-MM");
            SimpleDateFormat formatyyyyMMddHHmmss = new SimpleDateFormat("yyyyMMddHHmmss");
            Date parse = formatyyyylMM.parse(date);

            Date startTimeOfCurrentMonth = DateUtils.getStartTimeOfCurrentMonth(parse);
            String formatStart = formatyyyyMMddHHmmss.format(startTimeOfCurrentMonth);

            Date endTimeOfCurrentMonth = DateUtils.getEndTimeOfCurrentMonth(parse);
            String formatEnd = formatyyyyMMddHHmmss.format(endTimeOfCurrentMonth);

            QueryWrapper<CqSwBargainResult> cqSwBargainResultQueryWrapper = new QueryWrapper<CqSwBargainResult>();
            cqSwBargainResultQueryWrapper.gt("TRADE_DATE",formatStart.substring(0,8));
            cqSwBargainResultQueryWrapper.le("TRADE_DATE",formatEnd.substring(0,8));
            cqSwBargainResultQueryWrapper.eq("PLATFORM_CODE",platformCode);
            cqSwBargainResultQueryWrapper.select("sum( case when PRICE_UNIT = 0 then TRADE_VALUE when PRICE_UNIT = 1 then TRADE_VALUE*10000 else TRADE_VALUE end) as sumAll");
            CqSwBargainResult cqSwBargainResult = cqSwBargainResultService.getOne(cqSwBargainResultQueryWrapper);

            QueryWrapper<CqGqBargainResult> cqGqBargainResultQueryWrapper = new QueryWrapper<CqGqBargainResult>();
            cqGqBargainResultQueryWrapper.gt("TRADE_DATE",formatStart.substring(0,8));
            cqGqBargainResultQueryWrapper.le("TRADE_DATE",formatEnd.substring(0,8));
            cqGqBargainResultQueryWrapper.eq("PLATFORM_CODE",platformCode);
            cqGqBargainResultQueryWrapper.select("sum( case when PRICE_UNIT = 0 then TRADE_VALUE when PRICE_UNIT = 1 then TRADE_VALUE*10000 else TRADE_VALUE end) as sumAll");

            CqGqBargainResult cqGqBargainResult = cqGqBargainResultService.getOne(cqGqBargainResultQueryWrapper);
            if(!ObjectUtils.isEmpty(cqSwBargainResult)){
                String sumAll = cqSwBargainResult.getSumAll();
                BigDecimal bigDecimalsumAll = new BigDecimal(sumAll);
                if(!ObjectUtils.isEmpty(cqGqBargainResult)){
                    String sumAllValue = cqGqBargainResult.getSumAll();
                    BigDecimal bigDecimalSumAllValue = new BigDecimal(sumAllValue);
                    bigDecimalsumAll = bigDecimalSumAllValue.add(bigDecimalsumAll);
                }
                lineChartDataGyValue[ilineChartDataGyValue] = bigDecimalsumAll.toString();
            }else{
                lineChartDataGyValue[ilineChartDataGyValue] = "0";
            }
            ilineChartDataGyValue++;
        }
        lineChartDataGy.setValue(lineChartDataGyValue);
        dataDataDataList.add(lineChartDataGy);

        LineChartData lineChartDataYm = new LineChartData();
        lineChartDataYm.setName("疫苗交易");
        lineChartDataYm.setDate(get6Month());
        dataDataDataList.add(lineChartDataYm);

        LineChartData lineChartDataQt = new LineChartData();
        lineChartDataQt.setDate(get6Month());
        String lineChartDataQtValue[] = new String[7];
        int ilineChartDataQtValue = 0;
        for (String date : lineChartDataQt.getDate()) {
            //开始时间
            SimpleDateFormat formatyyyylMM = new SimpleDateFormat("yyyy-MM");
            SimpleDateFormat formatyyyyMMddHHmmss = new SimpleDateFormat("yyyyMMddHHmmss");
            Date parse = formatyyyylMM.parse(date);

            Date startTimeOfCurrentMonth = DateUtils.getStartTimeOfCurrentMonth(parse);
            String formatStart = formatyyyyMMddHHmmss.format(startTimeOfCurrentMonth);

            Date endTimeOfCurrentMonth = DateUtils.getEndTimeOfCurrentMonth(parse);
            String formatEnd = formatyyyyMMddHHmmss.format(endTimeOfCurrentMonth);

            QueryWrapper<QtjyBidpublicity> qtjyBidpublicityQueryWrapper = new QueryWrapper<QtjyBidpublicity>();
            qtjyBidpublicityQueryWrapper.gt("PUBLISHING_TIME",formatStart);
            qtjyBidpublicityQueryWrapper.le("PUBLISHING_TIME",formatEnd);
            qtjyBidpublicityQueryWrapper.eq("PLATFORM_CODE",platformCode);
            qtjyBidpublicityQueryWrapper.select("sum(BID_AMOUNT) as sumAll");
            QtjyBidpublicity qtjyBidpublicity = qtjyBidpublicityService.getOne(qtjyBidpublicityQueryWrapper);
            if(!ObjectUtils.isEmpty(qtjyBidpublicity)){
                String sumAll = qtjyBidpublicity.getSumAll();
                lineChartDataQtValue[ilineChartDataQtValue] = sumAll;
            }else{
                lineChartDataQtValue[ilineChartDataQtValue] = "0";
            }
            ilineChartDataQtValue++;
        }
        lineChartDataQt.setValue(lineChartDataQtValue);
        lineChartDataQt.setName("其他交易");
        dataDataDataList.add(lineChartDataQt);


        return Result.OK(dataDataDataList);
    }


    public String[] get6Month() throws ParseException {
        Calendar c = Calendar.getInstance();
        c.add(Calendar.MONTH, -5);
        String before_six = c.get(Calendar.YEAR) + "-" + c.get(Calendar.MONTH);//六个月前
        ArrayList<String> result = new ArrayList<String>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM");// 格式化为年月
        Calendar min = Calendar.getInstance();
        Calendar max = Calendar.getInstance();
        min.setTime(sdf.parse(before_six));
        min.set(min.get(Calendar.YEAR), min.get(Calendar.MONTH), 1);
        max.setTime(sdf.parse(sdf.format(new Date())));
        max.set(max.get(Calendar.YEAR), max.get(Calendar.MONTH), 2);
        Calendar curr = min;
        while (curr.before(max)) {
            result.add(sdf.format(curr.getTime()));
            curr.add(Calendar.MONTH, 1);
        }
        String date[] = new String[7];
        int i = 0;
        for (String sDate : result) {
            date[i] = sDate;
            i++;
        }
        return date;
    }

    public Integer getGcTenderprojectTotal(Date startTime, Date endTime){
        String strDateFormat = "yyyyMMddHHmmss";
        Long resultStartTime  = Long.parseLong(DateFormatUtils.format(startTime,strDateFormat));
        Long resultEndTime  = Long.parseLong(DateFormatUtils.format(endTime,strDateFormat));
        QueryWrapper<GcTenderproject> gcTenderprojectMapperQueryWrapper = new QueryWrapper<GcTenderproject>();
        gcTenderprojectMapperQueryWrapper.ge("CREATE_TIME",resultStartTime);
        gcTenderprojectMapperQueryWrapper.le("CREATE_TIME",resultEndTime);
        int count = gcTenderprojectService.count(gcTenderprojectMapperQueryWrapper);

        QueryWrapper<ZcProject> zcProjectQueryWrapper = new QueryWrapper<ZcProject>();
        zcProjectQueryWrapper.ge("CREATE_TIME",resultStartTime);
        zcProjectQueryWrapper.le("CREATE_TIME",resultEndTime);
        int countZcProject = zcProjectService.count(zcProjectQueryWrapper);

        QueryWrapper<QtjyTenderProject> QtjyTenderProjectQueryWrapper = new QueryWrapper<QtjyTenderProject>();
        QtjyTenderProjectQueryWrapper.ge("CREATE_TIME",resultStartTime);
        QtjyTenderProjectQueryWrapper.le("CREATE_TIME",resultEndTime);
        int countQtjyTenderProject = qtjyTenderProjectService.count(QtjyTenderProjectQueryWrapper);

        return count + countZcProject + countQtjyTenderProject;
    }

    public Integer getGcNoticeandfileTotalByOpenTime(Date startTime,Date endTime){
        String strDateFormat = "yyyyMMddHHmmss";
        Long resultStartTime  = Long.parseLong(DateFormatUtils.format(startTime,strDateFormat));
        Long resultEndTime  = Long.parseLong(DateFormatUtils.format(endTime,strDateFormat));
        QueryWrapper<GcNoticeandfile> gcTenderprojectMapperQueryWrapper = new QueryWrapper<GcNoticeandfile>();
        gcTenderprojectMapperQueryWrapper.ge("BID_OPEN_TIME",resultStartTime);
        gcTenderprojectMapperQueryWrapper.le("BID_OPEN_TIME",resultEndTime);
        int count = gcNoticeandfileService.count(gcTenderprojectMapperQueryWrapper);


        QueryWrapper<QtjyBidopenrecord> qtjyBidopenrecordQueryWrapper = new QueryWrapper<QtjyBidopenrecord>();
        qtjyBidopenrecordQueryWrapper.ge("BID_OPENING_TIME",resultStartTime);
        qtjyBidopenrecordQueryWrapper.le("BID_OPENING_TIME",resultEndTime);
        int countzcBidpublicity = qtjyBidopenrecordService.count(qtjyBidopenrecordQueryWrapper);

        QueryWrapper<ZcBidopenrecord> zcBidopenrecordQueryWrapper = new QueryWrapper<ZcBidopenrecord>();
        zcBidopenrecordQueryWrapper.ge("BID_OPENING_TIME",resultStartTime);
        zcBidopenrecordQueryWrapper.le("BID_OPENING_TIME",resultEndTime);
        int countZcBidopenrecord = zcBidopenrecordService.count(zcBidopenrecordQueryWrapper);


        return count + countzcBidpublicity + countZcBidopenrecord;
    }

    public Integer getGcNoticeandfileTotalByNoticeSendTime(Date startTime,Date endTime){
        String strDateFormat = "yyyyMMddHHmmss";
        Long resultStartTime  = Long.parseLong(DateFormatUtils.format(startTime,strDateFormat));
        Long resultEndTime  = Long.parseLong(DateFormatUtils.format(endTime,strDateFormat));
        QueryWrapper<GcNoticeandfile> gcTenderprojectMapperQueryWrapper = new QueryWrapper<GcNoticeandfile>();
        gcTenderprojectMapperQueryWrapper.ge("NOTICE_SEND_TIME",resultStartTime);
        gcTenderprojectMapperQueryWrapper.le("NOTICE_SEND_TIME",resultEndTime);
        int count = gcNoticeandfileService.count(gcTenderprojectMapperQueryWrapper);

        QueryWrapper<ZcPurchaseBulletin> zcPurchaseBulletinQueryWrapper = new QueryWrapper<ZcPurchaseBulletin>();
        zcPurchaseBulletinQueryWrapper.ge("BULLETIN_START_TIME",resultStartTime);
        zcPurchaseBulletinQueryWrapper.le("BULLETIN_START_TIME",resultEndTime);
        int countZcPurchaseBulletin = zcPurchaseBulletinService.count(zcPurchaseBulletinQueryWrapper);

        QueryWrapper<QtjyNotice> qtjyNoticeQueryWrapper = new QueryWrapper<QtjyNotice>();
        qtjyNoticeQueryWrapper.ge("PUBLISHING_TIME",resultStartTime);
        qtjyNoticeQueryWrapper.le("PUBLISHING_TIME",resultEndTime);
        int countQtjyNotice = qtjyNoticeService.count(qtjyNoticeQueryWrapper);

        return count + countZcPurchaseBulletin + countQtjyNotice;
    }
    public Integer getGcBidpublicityTotal(Date startTime,Date endTime){
        String strDateFormat = "yyyyMMddHHmmss";
        Long resultStartTime  = Long.parseLong(DateFormatUtils.format(startTime,strDateFormat));
        Long resultEndTime  = Long.parseLong(DateFormatUtils.format(endTime,strDateFormat));
        QueryWrapper<GcBidpublicity> gcBidpublicityQueryWrapper = new QueryWrapper<GcBidpublicity>();
        gcBidpublicityQueryWrapper.ge("NOTICE_SEND_TIME",resultStartTime);
        gcBidpublicityQueryWrapper.le("NOTICE_SEND_TIME",resultEndTime);
        int count = gcBidpublicityService.count(gcBidpublicityQueryWrapper);

        QueryWrapper<ZcBidpublicity> zcBidpublicityQueryWrapper = new QueryWrapper<ZcBidpublicity>();
        zcBidpublicityQueryWrapper.ge("WIN_BID_BULLETIN_START_TIME",resultStartTime);
        zcBidpublicityQueryWrapper.le("WIN_BID_BULLETIN_START_TIME",resultEndTime);
        int countZcBidpublicity = zcBidpublicityService.count(zcBidpublicityQueryWrapper);

        QueryWrapper<QtjyBidpublicity> qtjyBidpublicityQueryWrapper = new QueryWrapper<QtjyBidpublicity>();
        qtjyBidpublicityQueryWrapper.ge("PUBLISHING_TIME",resultStartTime);
        qtjyBidpublicityQueryWrapper.le("PUBLISHING_TIME",resultEndTime);
        int countQtjyBidpublicity = qtjyBidpublicityService.count(qtjyBidpublicityQueryWrapper);

        return count + countZcBidpublicity + countQtjyBidpublicity;
    }
}
